package nl.voidcorp.adminplugin

import nl.voidcorp.adminplugin.commands.HealCommand
import nl.voidcorp.adminplugin.commands.NotifyBarCommand
import nl.voidcorp.mainplugin.CommandHandler
import nl.voidcorp.mainplugin.VoidPluginBase
import nl.voidcorp.mainplugin.adapter
import nl.voidcorp.mainplugin.messaging.Message
import nl.voidcorp.mainplugin.messaging.MessageType
import nl.voidcorp.mainplugin.moshi

class VoidAdmin(override val comment: String = "Make admins even more overpowered...") : VoidPluginBase() {
    lateinit var config: AdminConfig
    override fun enable() {
        send("VoidPlugin", MessageType.GET_CONFIG)
        send("VoidPlugin", MessageType.POST_CONFIG, moshi.adapter<AdminConfig>().toJson(config))

        server.pluginManager.registerEvents(VoidEvents(config), this)

        CommandHandler(this)
            .registerCommand("heal", HealCommand())
            .registerCommand("notifybar", NotifyBarCommand(this))

    }

    override fun disable() {
        send("VoidPlugin", MessageType.POST_CONFIG, moshi.adapter<AdminConfig>().toJson(config))
    }

    override fun recieve(message: Message) {
        when (message.messageType) {
            MessageType.GET_CONFIG -> {
                config = moshi.adapter<AdminConfig>().fromJson(message.content)!!
            }
            else->{}
        }
    }
}