package nl.voidcorp.adminplugin.commands

import nl.voidcorp.mainplugin.VoidPluginBase
import nl.voidcorp.mainplugin.commands.VoidCommand
import org.bukkit.Bukkit
import org.bukkit.NamespacedKey
import org.bukkit.boss.BarColor
import org.bukkit.boss.BarFlag
import org.bukkit.boss.BarStyle
import org.bukkit.command.Command
import org.bukkit.command.CommandSender
import org.bukkit.entity.Player
import kotlin.concurrent.fixedRateTimer

class NotifyBarCommand(plugin: VoidPluginBase) : VoidCommand() {
    private val ns = NamespacedKey(plugin, "NotifyBar")
    override fun onCommand(sender: CommandSender, command: Command, label: String, args: Array<out String>): Boolean {
        if (sender is Player) {
            if (args.isEmpty()) {
                sender.sendMessage("You need to supply a message!")
            }
            Bukkit.createBossBar(
                ns,
                args.joinToString(" "),
                BarColor.RED,
                BarStyle.SOLID,
                BarFlag.DARKEN_SKY
            ).apply {
                Bukkit.getServer().onlinePlayers.forEach { addPlayer(it) }
                progress = 1.0
            }
            fixedRateTimer(period = 100) {
                val bar = Bukkit.getBossBar(ns)!!
                try {
                    bar.progress -= 0.01
                } catch (ex: IllegalArgumentException) {
                    bar.removeAll()
                    this.cancel()
                }
            }
        }
        return true
    }
}