package nl.voidcorp.bankplugin.commands

import nl.voidcorp.bankplugin.BankConfig
import nl.voidcorp.bankplugin.VoidBank
import nl.voidcorp.bankplugin.costcalc.Collector
import nl.voidcorp.mainplugin.adapter
import nl.voidcorp.mainplugin.commands.VoidCommand
import nl.voidcorp.mainplugin.messaging.MessageType
import nl.voidcorp.mainplugin.moshi
import org.bukkit.command.Command
import org.bukkit.command.CommandSender

class ReloadCommand(private val bank: VoidBank) : VoidCommand() {
    override fun onCommand(sender: CommandSender, command: Command, label: String, args: Array<out String>): Boolean {
        if (!sender.hasPermission("bank.reload")) return false

        bank.send("VoidPlugin", MessageType.GET_CONFIG)
        bank.send("VoidPlugin", MessageType.POST_CONFIG, moshi.adapter<BankConfig>().toJson(VoidBank.config))
        Collector.reloadConfig()
        bank.iconMenu()
        return true
    }
}