package nl.voidcorp.bankplugin.commands

import nl.voidcorp.mainplugin.commands.VoidCommand
import org.bukkit.Bukkit
import org.bukkit.Material
import org.bukkit.command.Command
import org.bukkit.command.CommandSender
import org.bukkit.entity.Player
import org.bukkit.inventory.ItemStack
import org.bukkit.inventory.MerchantRecipe

class WoodStripCommand : VoidCommand() {
    override fun onCommand(sender: CommandSender, command: Command, label: String, args: Array<out String>): Boolean {
        if (sender is Player) {
            val merchant = Bukkit.createMerchant("Wood Stripper")

            val cursed = "STRIPPED_(.*)_LOG".toRegex()
            val logs = Material.values().toList().filter { it.name.matches(cursed) }
                .map { cursed.matchEntire(it.name)!!.groupValues[1] }
            val recipes =
                logs.map {
                    MerchantRecipe(ItemStack(Material.getMaterial("${it}_LOG")!!), Int.MAX_VALUE).apply {
                        addIngredient(ItemStack(Material.getMaterial("STRIPPED_${it}_LOG")!!))
                    }
                }.toMutableList()
            merchant.recipes = recipes
            sender.openMerchant(merchant, true)
        }
        return true
    }
}