package nl.voidcorp.teleportplugin

import nl.voidcorp.teleportplugin.models.TeleportLocation
import nl.voidcorp.teleportplugin.models.TeleportLocations
import org.bukkit.Location
import org.bukkit.entity.Player
import org.bukkit.event.EventHandler
import org.bukkit.event.Listener
import org.bukkit.event.entity.EntityDamageEvent
import org.bukkit.event.player.PlayerTeleportEvent
import org.jetbrains.exposed.sql.transactions.transaction

object TpEvents : Listener {

    @EventHandler
    fun onDeath(evt: EntityDamageEvent) {
        val entity = evt.entity
        if (entity is Player) {
            if (entity.health <= 0.0) {
                setLastTpLoc(entity)
            }
        }
    }

    @EventHandler
    fun onTeleport(evt: PlayerTeleportEvent) {
        setLastTpLoc(evt.player, evt.from)
    }

    fun setLastTpLoc(player: Player, location: Location = player.location) {
        transaction {
            val tp = TeleportLocation.find { TeleportLocations.player eq player.uniqueId }.firstOrNull()
            if (tp == null)
                TeleportLocation.new {
                    this.location = location
                    this.player = player.uniqueId
                }
            else
                tp.location = location
        }
    }
}