package nl.voidcorp.teleportplugin

import nl.voidcorp.mainplugin.CommandHandler
import nl.voidcorp.mainplugin.VoidPluginBase
import nl.voidcorp.teleportplugin.commands.SpawnCommand
import nl.voidcorp.teleportplugin.commands.home.DelHomeCommand
import nl.voidcorp.teleportplugin.commands.home.HomeCommand
import nl.voidcorp.teleportplugin.commands.home.ListHomeCommand
import nl.voidcorp.teleportplugin.commands.home.SetHomeCommand
import nl.voidcorp.teleportplugin.commands.tpx.*
import nl.voidcorp.teleportplugin.commands.warp.DelWarpCommand
import nl.voidcorp.teleportplugin.commands.warp.SetWarpCommand
import nl.voidcorp.teleportplugin.commands.warp.WarpCommand
import nl.voidcorp.teleportplugin.models.Homes
import nl.voidcorp.teleportplugin.models.TeleportLocations
import nl.voidcorp.teleportplugin.models.TpRequests
import nl.voidcorp.teleportplugin.models.Warps
import org.jetbrains.exposed.sql.SchemaUtils
import org.jetbrains.exposed.sql.SqlExpressionBuilder.lessEq
import org.jetbrains.exposed.sql.deleteWhere
import org.jetbrains.exposed.sql.transactions.transaction
import org.joda.time.DateTime

class VoidTeleport(override val comment: String = "Teleport around :D") :
    VoidPluginBase() {

    override fun enable() {
        CommandHandler(this)
            .registerCommand("spawn", SpawnCommand())
            .registerCommand("sethome", SetHomeCommand())
            .registerCommand("home", HomeCommand())
            .registerCommand("delhome", DelHomeCommand())
            .registerCommand("homes", ListHomeCommand(HomeCommand(), "Your homes are"))
            .registerCommand("warp", WarpCommand())
            .registerCommand("setwarp", SetWarpCommand())
            .registerCommand("delwarp", DelWarpCommand())
            .registerCommand("warps", ListHomeCommand(WarpCommand(),"The warps are"))
            .registerCommand("tpa", TpaCommand())
            .registerCommand("tphere", TpHereCommand())
            .registerCommand("tpaccept", TpAcceptCommand())
            .registerCommand("tpdeny", TpDenyCommand())
            .registerCommand("back",BackCommand())
        server.pluginManager.registerEvents(TpEvents, this)
        transaction {
            SchemaUtils.createMissingTablesAndColumns(Homes, Warps, TpRequests, TeleportLocations)
            TpRequests.deleteWhere { TpRequests.timeout lessEq DateTime.now() }
        }
    }
}