package nl.voidcorp.teleportplugin.commands.tpx

import nl.voidcorp.mainplugin.commands.VoidCommand
import nl.voidcorp.teleportplugin.models.TeleportLocation
import nl.voidcorp.teleportplugin.models.TeleportLocations
import org.bukkit.command.Command
import org.bukkit.command.CommandSender
import org.bukkit.entity.Player
import org.jetbrains.exposed.sql.transactions.transaction

class BackCommand : VoidCommand() {
    override fun onCommand(sender: CommandSender, command: Command, label: String, args: Array<out String>): Boolean {
        return if (sender is Player) {
            transaction {
                val tp = TeleportLocation.find { TeleportLocations.player eq sender.uniqueId }.firstOrNull()
                if (tp == null) {
                    sender.sendMessage("Sorry, you don't have a location to go back to on record...")
                } else {
                    sender.teleport(tp.location)
                    sender.sendMessage("Welcome back!")
                }
            }
            true
        } else false
    }
}