package nl.voidcorp.teleportplugin.commands.tpx

import nl.voidcorp.mainplugin.commands.VoidCommand
import nl.voidcorp.teleportplugin.models.TpRequest
import nl.voidcorp.teleportplugin.models.TpRequests
import org.bukkit.Bukkit
import org.bukkit.command.Command
import org.bukkit.command.CommandSender
import org.bukkit.entity.Player
import org.jetbrains.exposed.sql.transactions.transaction
import java.util.*

class TpDenyCommand : VoidCommand() {
    override fun onCommand(sender: CommandSender, command: Command, label: String, args: Array<out String>): Boolean {
        if (sender is Player) {
            transaction {
                val req = TpRequest.find { TpRequests.to eq sender.uniqueId }.toList()
                if (req.isEmpty()) {
                    sender.sendMessage("You have no requests open...")
                } else {
                    val teleport = req.first()
                    val from = Bukkit.getPlayer(teleport.from)
                    if (from != null) {
                        sender.sendMessage("Denied request from ${from.displayName}")
                    }
                    teleport.delete()
                }
            }
        }
        return true
    }
}