package nl.voidcorp.teleportplugin.commands.tpx

import net.md_5.bungee.api.chat.ClickEvent
import net.md_5.bungee.api.chat.TextComponent
import nl.voidcorp.mainplugin.commands.VoidCommand
import nl.voidcorp.teleportplugin.models.TpRequest
import nl.voidcorp.teleportplugin.models.TpRequests
import org.bukkit.Bukkit
import org.bukkit.ChatColor
import org.bukkit.command.Command
import org.bukkit.command.CommandSender
import org.bukkit.entity.Player
import org.jetbrains.exposed.sql.and
import org.jetbrains.exposed.sql.deleteWhere
import org.jetbrains.exposed.sql.transactions.transaction
import org.joda.time.DateTime

class TpHereCommand : VoidCommand() {
    override fun onTabComplete(
        sender: CommandSender,
        command: Command,
        alias: String,
        args: Array<out String>
    ): List<String> {
        if (sender is Player) {
            val toComplete = args.lastOrNull() ?: ""
            return Bukkit.getOnlinePlayers().toList().map { ChatColor.stripColor(it.name)!! }
                .filter { it.startsWith(toComplete) }
        }

        return emptyList()
    }

    override fun onCommand(sender: CommandSender, command: Command, label: String, args: Array<out String>): Boolean {
        if (sender is Player) {
            if (args.isEmpty()) {
                sender.sendMessage("The first argument should be a nickname of an online player")
                return true
            }
            val pl = Bukkit.getPlayer(args.first())
            if (pl == null || !pl.isOnline) {
                sender.sendMessage("The first argument should be a nickname of an online player")
                return true
            }
            transaction {
                TpRequests.deleteWhere { TpRequests.timeout lessEq DateTime.now() }

                if (TpRequest.find { TpRequests.to eq pl.uniqueId }.toList().isNotEmpty()) {
                    sender.sendMessage("${pl.displayName} already has a request open...")
                    if (TpRequest.find { (TpRequests.from eq sender.uniqueId) and (TpRequests.to eq pl.uniqueId) }.toList().isNotEmpty()) {
                        sender.sendMessage("Actually, you sent that request...")
                    }
                } else {
                    TpRequest.new {
                        from = sender.uniqueId
                        to = pl.uniqueId
                        here = true
                    }
                    sender.sendMessage("Sent a teleport request to ${pl.displayName}")
                    pl.sendMessage(
                        TextComponent("Received a new Teleport request from "),
                        TextComponent(sender.displayName).apply { color = net.md_5.bungee.api.ChatColor.AQUA },
                        TextComponent(" to teleport to them, use "),
                        TextComponent("/tpaccept").apply {
                            color = net.md_5.bungee.api.ChatColor.GREEN
                            clickEvent = ClickEvent(ClickEvent.Action.RUN_COMMAND, "/tpaccept")
                        },
                        TextComponent(" or "),
                        TextComponent("/tpdeny").apply {
                            color = net.md_5.bungee.api.ChatColor.RED
                            clickEvent = ClickEvent(ClickEvent.Action.RUN_COMMAND, "/tpdeny")
                        },
                        TextComponent(" to accept or deny it!")
                    )
                    //pl.sendMessage("Received a new teleport request from ${sender.displayName}, use /tpaccept or /tpdeny to accept or deny it!")
                }
            }
        }
        return true
    }
}