package nl.voidcorp.teleportplugin.commands.warp

import nl.voidcorp.mainplugin.commands.VoidCommand
import nl.voidcorp.teleportplugin.models.Warp
import nl.voidcorp.teleportplugin.models.Warps
import org.bukkit.command.Command
import org.bukkit.command.CommandSender
import org.bukkit.entity.Player
import org.jetbrains.exposed.sql.transactions.transaction

class DelWarpCommand : VoidCommand() {

    override fun onTabComplete(
        sender: CommandSender,
        command: Command,
        alias: String,
        args: Array<out String>
    ): List<String> {
        return if (sender is Player) {
            transaction {
                Warp.find { Warps.name like "${args.lastOrNull() ?: ""}%" }.map { it.name }
            }
        } else mutableListOf()
    }

    override fun onCommand(sender: CommandSender, command: Command, label: String, args: Array<out String>): Boolean {
        if (sender is Player) {
            if (!sender.hasPermission("voidteleport.setwarp")) return false
            if (args.isEmpty()) {
                sender.sendMessage("You need to specify a warp name!")
                return true
            }
            val loc = args.first()
            transaction {
                val warp = Warp.find { Warps.name eq loc }.firstOrNull()
                if (warp != null) {
                    warp.delete()
                    sender.sendMessage("The warp $loc has been deleted")
                } else {
                    sender.sendMessage("The warp $loc does not exist?")
                }
            }
        }
        return true
    }
}