package nl.voidcorp.teleportplugin.commands.warp

import nl.voidcorp.mainplugin.commands.VoidCommand
import nl.voidcorp.teleportplugin.models.Warp
import nl.voidcorp.teleportplugin.models.Warps
import org.bukkit.command.Command
import org.bukkit.command.CommandSender
import org.bukkit.entity.Player
import org.jetbrains.exposed.sql.transactions.transaction

class SetWarpCommand : VoidCommand() {
    override fun onCommand(sender: CommandSender, command: Command, label: String, args: Array<out String>): Boolean {
        if (sender is Player) {
            if (!sender.hasPermission("voidteleport.setwarp")) return false
            if (args.isEmpty()) {
                sender.sendMessage("You need to specify a warp name!")
                return true
            }
            val loc = args.first()
            transaction {
                val warp = Warp.find {
                    Warps.name eq (args.firstOrNull() ?: "home")
                }.any()
                if (warp) {
                    sender.sendMessage("The warp '$loc' already exists!")
                } else {
                    Warp.new {
                        location = sender.location
                        this.name = loc
                    }
                    sender.sendMessage("Created warp '$loc'")
                }
            }
        }
        return true
    }
}