package nl.voidcorp.teleportplugin.models

import org.bukkit.Bukkit
import org.bukkit.Location
import org.jetbrains.exposed.dao.EntityID
import org.jetbrains.exposed.dao.IntEntity
import org.jetbrains.exposed.dao.IntEntityClass

class TeleportLocation(id: EntityID<Int>) : IntEntity(id) {
    companion object : IntEntityClass<TeleportLocation>(TeleportLocations)

    var player by TeleportLocations.player
    var x by TeleportLocations.x
    var y by TeleportLocations.y
    var z by TeleportLocations.z
    var world by TeleportLocations.world
    var pitch by TeleportLocations.pitch
    var yaw by TeleportLocations.yaw
    var location: Location
        get() = Location(Bukkit.getWorld(world), x, y, z, yaw, pitch)
        set(value) {
            this.x = value.x
            this.y = value.y
            this.z = value.z
            this.world = value.world.uid
            this.yaw = value.yaw
            this.pitch = value.pitch
        }
}