package nl.voidcorp.utilsplugin

import org.bukkit.ChatColor
import org.bukkit.event.EventHandler
import org.bukkit.event.Listener
import org.bukkit.event.player.PlayerBedEnterEvent
import org.bukkit.event.player.PlayerBedLeaveEvent
import org.bukkit.event.player.PlayerJoinEvent
import org.jetbrains.exposed.sql.transactions.transaction
import java.util.*
import kotlin.math.roundToInt

class Events(private val utils: VoidUtils) : Listener {
    @EventHandler
    fun onJoin(evt: PlayerJoinEvent) {
        transaction {
            val nick = Nick.find { NickTable.userid eq evt.player.uniqueId }.firstOrNull()?.nickname
            if (nick != null) {
                evt.player.setDisplayName(nick)
            }
        }
    }

    private val bedList = mutableSetOf<UUID>()

    @EventHandler
    fun onBedEnter(evt: PlayerBedEnterEvent) {
        if (evt.bedEnterResult != PlayerBedEnterEvent.BedEnterResult.OK) return
        val id = evt.player.uniqueId
        bedList.add(id)
        val req = (utils.conf.neededPlayers * evt.player.server.onlinePlayers.size).roundToInt()
        if (bedList.size >= req) {
            utils.server.worlds.forEach { it.time = 0 }
            if (evt.player.world.isThundering) {
                evt.player.world.weatherDuration = 1
            }
            utils.server.broadcastMessage("Enough players were sleeping, skipping the night!")
        } else
            utils.server.broadcastMessage("There are now ${ChatColor.GOLD}${bedList.size}/$req${ChatColor.RESET} players sleeping to skip the night!")
    }

    @EventHandler
    fun onBedLeave(evt: PlayerBedLeaveEvent) {
        val id = evt.player.uniqueId
        bedList.remove(id)
    }

}