package nl.voidcorp.utilsplugin

import nl.voidcorp.mainplugin.CommandHandler
import nl.voidcorp.mainplugin.VoidPluginBase
import nl.voidcorp.mainplugin.adapter
import nl.voidcorp.mainplugin.messaging.Message
import nl.voidcorp.mainplugin.messaging.MessageType
import nl.voidcorp.mainplugin.moshi
import nl.voidcorp.utilsplugin.commands.MemeCommand
import nl.voidcorp.utilsplugin.commands.NickCommand
import org.jetbrains.exposed.sql.SchemaUtils
import org.jetbrains.exposed.sql.transactions.transaction

class VoidUtils(override val comment: String = "Add some useful utilities!") : VoidPluginBase() {
    lateinit var conf: UtilsConfig
    override fun enable() {
        transaction {
            SchemaUtils.createMissingTablesAndColumns(NickTable)
        }

        send("VoidPlugin", MessageType.GET_CONFIG)
        send("VoidPlugin", MessageType.POST_CONFIG, moshi.adapter<UtilsConfig>().toJson(conf))

        CommandHandler(this)
            .registerCommand("memes", MemeCommand())
            .registerCommand("nick", NickCommand())

        server.pluginManager.registerEvents(Events(this), this)

    }

    override fun recieve(message: Message) {
        when (message.messageType) {
            MessageType.GET_CONFIG -> {
                conf = moshi.adapter<UtilsConfig>().fromJson(message.content)!!
            }
            else -> Unit
        }
    }
}